MODULE modulePeople

  TYPE, PUBLIC:: classPerson
    CHARACTER(:), ALLOCATABLE:: name
    INTEGER:: age
    CHARACTER(LEN=1):: gender
    TYPE(classPerson), POINTER:: partner => NULL()
    TYPE(classPerson), POINTER:: father => NULL(), mother => NULL()
    CONTAINS
      PROCEDURE, PASS:: output => outputPerson

  END TYPE classPerson

  CONTAINS
    SUBROUTINE outputPerson(self)
      IMPLICIT NONE
      CLASS(classPerson), INTENT(in):: self
      CLASS(classPerson), POINTER:: partner
      CLASS(classPerson), POINTER:: father, mother

      WRITE (*, '(A9,6X,I4,8X,A2,8X,L2,1X)') self%name, self%age, self%gender, ASSOCIATED(self%partner)
      partner => self%partner
      father => self%father
      mother => self%mother
      IF (ASSOCIATED(partner) .OR. &
          ASSOCIATED(father)  .OR. &
          ASSOCIATED(mother)) THEN
        WRITE (*, '(20X,A)') REPEAT('-',20)

        !Print partner information
        IF (ASSOCIATED(partner)) THEN
          WRITE (*, '(20X,A,1X,A9)') 'Partner:', partner%name

        END IF

        !Print father information
        IF (ASSOCIATED(father)) THEN
          WRITE (*, '(20X,A,1X,A9)') 'Father:', father%name

        END IF

        !Print mother information
        IF (ASSOCIATED(mother)) THEN
          WRITE (*, '(20X,A,1X,A9)') 'Mother:', mother%name

        END IF

      END IF

    END SUBROUTINE outputPerson


END MODULE modulePeople
