MODULE modulePeople

  TYPE, PUBLIC:: classPerson
    CHARACTER(:), ALLOCATABLE:: name
    INTEGER:: age
    CHARACTER(LEN=1):: gender
    TYPE(classPerson), POINTER:: partner => NULL()
    TYPE(classPerson), POINTER:: father => NULL(), mother => NULL()
    CONTAINS
      PROCEDURE, PASS:: output => outputPerson

  END TYPE classPerson

  CONTAINS
    SUBROUTINE outputPerson(self, level)
      IMPLICIT NONE

      CLASS(classPerson), INTENT(in):: self
      INTEGER, INTENT(in):: level
      CLASS(classPerson), POINTER:: partner
      CLASS(classPerson), POINTER:: father, mother
      CHARACTER(LEN=2):: levelString

      WRITE(levelString,'(I2)') level*6+1
      WRITE (*, '(' // levelString // 'X,A9,1X,A9,1X,A9,1X)') 'Name', 'Age', 'Gender'
      WRITE (*, '(' // levelString // 'X,A9,6X,I4,8X,A2,8X)') self%name, self%age, self%gender

      partner => self%partner
      IF (ASSOCIATED(partner)) THEN
        WRITE (*, '(' // levelString // 'X, A)') '-- Married to --'
        WRITE (*, '(' // levelString // 'X,A9,6X,I4,8X,A2,8X)') partner%name, partner%age, partner%gender

      END IF
      father => self%father
      IF (ASSOCIATED(father)) THEN
        WRITE (*, '(' // levelString // 'X, A)') '-- Father: --'
        CALL father%output(level + 1)

      END IF

      mother => self%mother
      IF (ASSOCIATED(mother)) THEN
        WRITE (*, '(' // levelString // 'X, A)') '-- Mother: --'
        CALL mother%output(level + 1)

      END IF

    END SUBROUTINE outputPerson

    SUBROUTINE outputTree(person)
      IMPLICIT NONE

      CLASS(classPerson), INTENT(in):: person
      INTEGER:: level = 0

      CALL person%output(level)

    END SUBROUTINE outputTree

END MODULE modulePeople
